%********************************************************************;
%*****                      Print functions                      ****;
%********************************************************************;

module riccir!-prt;

% Author: Jozsef Kadlecsik

% Modifications for fancy printing are from Herbert Melenk;

global '(levi!-civitamods!* levi!-civitasign!* spare!*);

fluid '(!*nat orig!* posn!* ycoord!* ymax!* ymin!* 
        !*diffprint !*fancy!-lower);


!*diffprint := t;  % remove it or don't remove it?

symbolic procedure !*iqprint u;
   sqprint !*msq2sq cadr u;

symbolic procedure !*timesprt u; 
   maprin if null cddr u then cadr u else 'times . cdr u;

put('!*timesprt,'expt,'inbrackets);

put('indvarprt,'expt,'inbrackets);

% An index may be:   up                        X
%                    up with tilde from rule   (!~ x)
%                    down                      (MINUS X)
%                    down with tilde from rule (MINUS (!~ X)) 

symbolic procedure indvarprt u;  % from EXCALC with modifications;
   if atom u then prin2!* u      
    else if null !*nat then << prin2!* car u;
                               prin2!* "(";
                               if cddr u 
                                 then inprint('!*comma!*,0,cdr u)
                                else maprin cadr u;
                               prin2!* ")" >>
          else begin scalar x,y; integer l;
            l := flatopl u;
            if l>(linelength nil-spare!*)-posn!* then terpri!* t;
            %avoid breaking of an indexed variable over a line;
            y := ycoord!*;
            signprt car u;
            if levi!-civitatp u 
               and levi!-civitasign!* and levi!-civitamods!*
              then << posn!* := posn!* - 1;
                      ycoord!* := y + 1;
                      if ycoord!*>ymax!* then ymax!* := ycoord!*;
                      if ycoord!*<ymin!* then ymin!* := ycoord!*;
                      signprt levi!-civitamods!*>>;
            for each j on cdr u do <<
               ycoord!* :=  y + if pos!-upp car j then 1 else -1;
               if ycoord!*>ymax!* then ymax!* := ycoord!*;
               if ycoord!*<ymin!* then ymin!* := ycoord!*;
               if atom(x := rem!-minus car j) then prin2!* x 
                else maprin x;
               if cdr j then prin2!* " ">>;
            ycoord!* := y
         end;

symbolic procedure flatopl u;
   if atom u then flatsizec u
    else if diffopp u 
           then (if car u eq 'ld then 2 else 1) +
                flatsizec flatindxl cddr u + flatopl cadr u
    else flatsizec flatindxl u + length cdr u - 1;

symbolic procedure flatindxl u;
   if null u then nil
    else if atom car u then car u . flatindxl cdr u 
    else if caar u eq '!~ then append(car u,flatindxl cdr u)
    else cadar u . flatindxl cdr u;

symbolic procedure pos!-upp u;
   atom u or car u eq '!~;

symbolic procedure rem!-minus u;
   if pos!-upp u then u else cadr u;

symbolic procedure gendiffprt u;
   if null !*nat then << dfsignprt car u;
                         prin2!* "(";
                         inprint('!*comma!*,0,cdr u);
                         prin2!* ")" >>
    else begin scalar x,y; integer l;
            l := flatopl u;
            if l>(linelength nil-spare!*)-posn!* then terpri!* t;
            %avoids breaking of the operator over a line;
            y := ycoord!*;
            if !*diffprint  
              then << if atom cadr u then prin2!* cadr u
                       else maprin cadr u;
                      ycoord!* := y - 1;
                      if ycoord!*>ymax!* then ymax!* := ycoord!*;
                      if ycoord!*<ymin!* then ymin!* := ycoord!*;
                      prin2!* " ";
                      dfsignprt car u>> 
             else signprt car u;
            for each j on cddr u do <<
               ycoord!* :=  y + if pos!-upp car j then 1 else -1;
               if ycoord!*>ymax!* then ymax!* := ycoord!*;
               if ycoord!*<ymin!* then ymin!* := ycoord!*;
               if atom(x := rem!-minus car j) then prin2!* x
                else maprin x;
               if cdr j or not !*diffprint then prin2!* " ">>;
            ycoord!* := y;
            if not !*diffprint  
              then if atom cadr u then prin2!* cadr u
                    else maprin cadr u
         end;

symbolic procedure signprt type; 
   prin2!*(get(type,'prtch) or type);

symbolic procedure dfsignprt type;
   prin2!* if type eq 'd then get('!*semicol!*,'prtch)
            else if type eq 'partdiff then get('!*comma!*,'prtch)
            else get(type,'prtch) or type;

symbolic procedure liedprt u;
   if null !*nat 
     then << signprt car u;
             prin2!* "(";
             inprint('!*comma!*,0,cdr u);
             prin2!* ")" >>
    else begin scalar y; integer l;
            l := flatopl u;
            if l>(linelength nil-spare!*)-posn!* then terpri!* t;
            %avoids breaking of the operator over a line;
            y := ycoord!*;
            signprt car u; 
            ycoord!* :=  y - 2;
            if ycoord!*>ymax!* then ymax!* := ycoord!*;
            if ycoord!*<ymin!* then ymin!* := ycoord!*;
            for each j in cddr u do <<
               maprin j;
               prin2!* " ">>;
            ycoord!* := y;
            if atom cadr u then prin2!* cadr u
             else maprin cadr u
         end;

symbolic procedure sqlistpri l;
   % This definition is basically that of INPRINT, except that it
   % decides when to split at the comma by looking at the size of
   % the argument.
   begin scalar orig,split,u;
      u := l;
      l := cdr l;
      prin2!* get('!*lsqb!*,'prtch);
         % Do it this way so table can change.
      orig := orig!*;
      orig!* := if posn!*<18 then posn!* else orig!*+3;
      if null l then go to b;
      split := treesizep(l,40);   % 40 is arbitrary choice.
   a: maprint(negnumberchk car l,0);
      l := cdr l;
      if null l then go to b;
      oprin '!*comma!*;
      if split then terpri!* t;
      go to a;
   b: prin2!* get('!*rsqb!*,'prtch);
%     terpri!* nil;
      orig!* := orig;
      return u
   end;

symbolic procedure fancy!-indvarprt(l,p);
   begin scalar q,x,w,b,s;
      q := fancy!-begin();
      if not(get('expt,'infix)>p) then <<
        w := fancy!-in!-brackets({'fancy!-indvarpr,mkquote l,0},
                                  '!(,'!));
        goto done>>;
      w := (fancy!-prefix!-operator car l) 
              where !*fancy!-lower=nil;
      if w eq 'failed then goto done;
      l := cdr l;
      while l and w neq 'failed do <<
        if b then fancy!-prin2!*("{}",0);
        x := car l; l := cdr l; b := t;
        if eqcar(x,'minus) then << x := cadr x; s:='!_;>> 
         else s:='!^;
        w := fancy!-print!-indexlist1({x},s,nil)>>;
   done:
      return fancy!-end(w,q);
   end;

% For an indexed quantity we need an additional property:
% put('aa,'fancy!-pprifn,'fancy!-indvarprt);

symbolic procedure fancy!-iqreform u;
   fancy!-sqreform {'!*sq,!*msq2sq cadr u,t};

put ('!*iq,'fancy!-reform,'fancy!-iqreform);

symbolic procedure fancy!-print!-riccirdf(u,n);
   begin scalar w;
      w := cadr u;
      if get (w,'fancy!-pprifn) = 'fancy!-indvarprt and (w:={w}) 
         or
         pairp w and get(car w,'fancy!-pprifn) = 'fancy!-indvarprt
        then return fancy!-indvarprt(append(w,
          (if car u = 'partdiff then '(minus !,) else '(minus !;))    
            . cddr u),n)
       else return 'failed;
  end;

symbolic procedure fancy!-riccirld(u,p);
   if p > get('times,'infix) 
     then fancy!-in!-brackets({'fancy!-riccirld,mkquote u,0},
                              '!(,'!))
    else begin scalar w,l;
            l := fancy!-begin();
            w := fancy!-indvarprt('ld. 
                    for each y in cddr u collect {'minus,y},0);
            if w neq 'failed then w := fancy!-maprint(cadr u,0); 
            return fancy!-end(w,l);
         end;

endmodule;

end;
