module riccir;  % Header module for RICCIR package.

% Author: Jozsef Kadlecsik

create!-package('(riccir      % Creating package;
                  intro       % Used signs, general modifications;
                  decls       % Declaration commands;
                  symm        % Symmetry declaration;
                  specs       % Declaration of objects from gen.rel.;
                  mods        % Modification (extension) of REDUCE; 
                  letfn       % LET function for indexed objects;
                  subsmsq     % Matching products, powers for ind. obj.;
                  where       % Parallel substitution of indices;
                  msq         % Modified standard quotient structure;
                  simp        % Simplification of ind. obj's and args.;
                  msqalg      % Elementary algebra of msq;
                  mult        % Multiplication of indexed objects;
                  ord         % Ordering of indexed objects;
                  util        % Utility functions;
                  gdiff       % General differentiation;
                  rels        % STATUS, RELATION;
                  callalgs    % Calling the built-in relations;
                  revrel      % Handling the reversed relations;
                  defs        % Relations from gen.rel.;
                  prt         % Printing functions;
                  abs0),      % Auxiliary rule;
                nil);
       
endmodule;

end;

