%********************************************************************;
%*****             Parallel substitution of indices              ****;
%********************************************************************;

module riccir!-where;

% Author: Jozsef Kadlecsik

fluid '(!*nosubs);

smacro procedure toplevelop u;
   u memq '(plus minus difference times !*times quotient recip);

symbolic procedure where!-list(u,v,w);
   (if null x then w else where!-list0(x,w))
      where x=indexpair(v,u);

symbolic procedure where!-list0(u,v);
   if null v or atom v then v
    else if diffopp v
     then if ldiffopp v then car v . where!-list0(u,cadr v) . cddr v
           else car v . where!-list0(u,cadr v) . indexsubla(u,cddr v)
    else if (tensorp v or symbolp v)
     then if numberp cdr v then v
           else car v . indexsubla(u,cdr v)
    else if toplevelop car v
     then car v . for each j in cdr v collect where!-list0(u,j)
      % Next line: the operator has been simplified now;
    else if get(car v,'simpfn) and car v neq '!*iq then v 
    else where!-list0(u,car v) . where!-list0(u,cdr v);

symbolic procedure where!-list!*(u,v,w);
   (if null x then w else where!-list0!*(x,w))
           where x=indexpair(v,u);

symbolic procedure where!-list0!*(u,v);
   if null v or atom v then v
    else if diffopp v
     then if ldiffopp v 
            then car v . where!-list0!*(u,cadr v) . cddr v
           else car v . where!-list0!*(u,cadr v) . indexsubla(u,cddr v)
    else if tensorp v or symbolp v
     then if numberp cdr v then v
           else car v . indexsubla(u,cdr v)
    else if toplevelop car v
     then car v . for each j in cdr v collect where!-list0!*(u,j)
    else if get(car v,'simpfn) and car v neq '!*iq then v 
    else if car v eq '!*iq then car v . where!-list0!*(u,cadr v) . cddr v
    else where!-list0!*(u,car v) . where!-list0!*(u,cdr v);

symbolic procedure indexsubla(u,v);
   for each j in v collect
     (if x then cdr x else j) where x=assoc(j,u);

symbolic procedure indexpair(u,v);
   if u  
     then if car u neq car v 
            then (car u . car v) . indexpair(cdr u,cdr v)
           else indexpair(cdr u,cdr v)
    else nil;

symbolic procedure tkern u;
   begin scalar x;
      if null subfg!* then return car fkern u
       else if null !*nosubs and (x := assoc(u,get(car u,'kvalue)))
        then nil
       else if not('used!* memq cddr (x := fkern u))
        then aconc(x,'used!*);
      return car x
   end;

symbolic procedure mktkern u;
   if null u or atom u then u
    else if indexedp u then tkern u
    else if get(car u,'simpfn) then u
    else mktkern car u . mktkern cdr u;

endmodule;

end;
